function CGameSection()
{
    var _oSectionContainer;
    var _oMsgBoxContainer;
    var _oVSText;
    var _oTextContinue;
    var _oMatchOverText;
    var _oHandsContainer;
    var _aPlayerOneSprites;
    var _aPlayerTwoSprites;
    var _aSpritesArrays;
    var _oHitArea;
    var _iTweenCounter;
    var _bRoundEnded;
    var _bMatchEnded = false;
    var _oTextTurn;
    var _oSound;
    this.init = function ()
    {
        s_oGameSection = this;
        _oSound = playSound("throw");
        _oSound.stop();
        _oSectionContainer = new createjs.Container();
        _oHandsContainer = new createjs.Container();
        oBg = createBitmap(s_oSpriteLibrary.getSprite("game_section"));
        _oSectionContainer.addChild(oBg);
        _oSectionContainer.addChild(_oHandsContainer);
        _oSectionContainer.x = 157;
        _oSectionContainer.y = 85;
        _oVSText = new createjs.Text("VS", "108px " + PRIMARY_FONT, "#c84343");
        _oMatchOverText = new createjs.Text("Match Ended", "68px " + PRIMARY_FONT, "#c84343");
        _oTextContinue = new createjs.Text("Click Here To Continue", "25px " + PRIMARY_FONT, "white");
        _oVSText.x = _oSectionContainer.getBounds().width / 2 - 60;
        _oTextContinue.x = _oSectionContainer.getBounds().width / 2 - 140;
        _oVSText.y = 80;
        _oTextContinue.y = 220;
        _oVSText.visible = false;
        _oTextContinue.visible = false;
        _oSectionContainer.addChild(_oTextContinue);
        _oSectionContainer.addChild(_oVSText);
        _aPlayerOneSprites = [];
        _aPlayerTwoSprites = [];
        _iTweenCounter = 0;
        _bRoundEnded = false;
        for (var i = 0; i < 3; i++) {
            oSprite = createBitmap(s_oSpriteLibrary.getSprite("p1_" + i));
            oSprite.y = 50 + oSprite.getBounds().height / 2;
            oSprite.x = 50 + oSprite.getBounds().width / 2;
            oSprite.regX = oSprite.getBounds().width / 2;
            oSprite.regY = oSprite.getBounds().height / 2;
            _aPlayerOneSprites.push(oSprite);
            _oHandsContainer.addChild(oSprite);
            oSprite.visible = false;
        }
        for (var i = 0; i < 3; i++) {
            oSprite = createBitmap(s_oSpriteLibrary.getSprite("p2_" + i));
            oSprite.y = 50 + oSprite.getBounds().height / 2;
            oSprite.x = 590 + oSprite.getBounds().width /2;
            oSprite.regX = oSprite.getBounds().width / 2;
            oSprite.regY = oSprite.getBounds().height / 2;
            _aPlayerTwoSprites.push(oSprite);
            _oHandsContainer.addChild(oSprite);
            oSprite.visible = false;
        }
        _aSpritesArrays = [_aPlayerOneSprites, _aPlayerTwoSprites];
        var _oContainerBounds = _oSectionContainer.getBounds();
        _oHitArea = new createjs.Shape();
        _oHitArea.graphics.beginFill("rgb(255,0,0").drawRect(0, 0, _oContainerBounds.width, _oContainerBounds.height);
        _oHitArea.alpha = 0.01;
        _oHitArea.on("mousedown", this.nextRound);
        _oHitArea.visible = false;
        
        _oMsgBoxContainer = new createjs.Container();
        oBg = createBitmap(s_oSpriteLibrary.getSprite("msg_box"));
        
        _oMsgBoxContainer.addChild(oBg);
        _oMsgBoxContainer.x = CANVAS_WIDTH/2 - oBg.getBounds().width/2;
        _oMsgBoxContainer.y = 600;
        _oTextTurn = new createjs.Text("Player One", "42px " + PRIMARY_FONT, "white");
        _oTextTurn.x = 100;
        _oTextTurn.y = 30;
        _oSectionContainer.addChild(_oTextTurn);
        _oSectionContainer.addChild(_oHitArea);
        s_oStage.addChild(_oSectionContainer);
    };


    this.toggleVisibleText = function ()
    {
        _oVSText.visible = !_oVSText.visible;
        _oTextContinue.visible = !_oTextContinue.visible;
    };
    this.unload = function ()
    {
        s_oStage.removeChild(_oSectionContainer);
    };

    this.matchOver = function (szMsg)
    {
        s_oStage.addChild(_oMsgBoxContainer);

        _bMatchEnded = true;
        _oHandsContainer.alpha = 0.5;
        this.toggleVisibleText();
        
        _oMatchOverText.text = szMsg;
        _oMatchOverText.x = _oMsgBoxContainer.getBounds().width / 2;
        _oMatchOverText.textAlign = "center";
        _oMatchOverText.lineWidth = 250;
        _oMatchOverText.lineHeight = 60;
        _oMsgBoxContainer.addChild(_oMatchOverText);
        new createjs.Tween.get(_oMsgBoxContainer).to({ y: CANVAS_HEIGHT - 550}, 600);
        _oMatchOverText.y = 80;
    };
    this.nextRound = function ()
    {
        s_oStage.removeChild(_oMsgBoxContainer);
        _oHandsContainer.alpha = 1;
        if (!s_bOnSelect && !_bMatchEnded)
        {
            _oHitArea.visible = false;

            s_oGame.nextRound();
            s_oGameSection.toggleVisibleText();

            for (var i = 0; i < _aPlayerOneSprites.length; i++) {
                _aPlayerOneSprites[i].visible = false;
            }
            for (var i = 0; i < _aPlayerTwoSprites.length; i++) {
                _aPlayerTwoSprites[i].visible = false;
            }
            _bRoundEnded = false;
        } else
        {
            s_oGame.restart();
        }
    };

    this.showThrowes = function (playerOne, playerTwo)
    {
        
            _oVSText.visible = true;
            _oTextTurn.visible = false;
            _oHitArea.visible = false;
            _aPlayerOneSprites[0].visible = true;
            _aPlayerOneSprites[0].alpha = 1;

            _aPlayerTwoSprites[0].visible = true;
            _aPlayerTwoSprites[0].alpha = 1;
            
            new createjs.Tween.get(_oHandsContainer)
                                                    .to({y: -30}, 200)
                                                    .call(this.playThrow)
                                                    .to({y: +30}, 200)
                                                    .call(this.playThrow)
                                                    .to({y: -30}, 400)
                                                    .call(this.playThrow)
                                                    .to({y: +30}, 200) 
                                                    .call(this.playThrow)
                                                    .to({y: 0}, 200)
                                                    .call(function ()
            {
                _oThis._showThrowes(playerOne, playerTwo);
                s_oGame.compareThrowes();
                _oTextContinue.visible = true;

            }
            );
        
    };
    this.playThrow = function ()
    {
       _oSound.play();
    }
    this._showThrowes = function (playerOne, playerTwo)
    {
        createjs.Tween.removeTweens(_oHandsContainer);
        if (!_bRoundEnded)
        {
            for (var i = 0; i < _aPlayerOneSprites.length; i++) {
                _aPlayerOneSprites[i].visible = false;
                _aPlayerOneSprites[i].alpha = 1;
            }
            for (var i = 0; i < _aPlayerTwoSprites.length; i++) {
                _aPlayerTwoSprites[i].visible = false;
                _aPlayerTwoSprites[i].alpha = 1;

            }
            _aPlayerOneSprites[playerOne].visible = true;
            _aPlayerTwoSprites[playerTwo].visible = true;
            _oHitArea.visible = true;

        }
        _bRoundEnded = true;

    };

    this.playerWonEffect = function (playerID)
    {
        var scale = 1.2;
        var time = 200;
            for (var i = 0; i < _aSpritesArrays[playerID].length; i++) {
                new createjs.Tween.get(_aSpritesArrays[playerID][i])
                        .to({scaleX: scale, scaleY: scale}, time)
                        .to({scaleX: 1, scaleY: 1}, time)
                        .to({scaleX: scale, scaleY: scale}, time)
                        .to({scaleX: 1, scaleY: 1}, time);
            }
    };
    this.playerLoseEffect = function (playerID)
    {
      var rotation = 10 * (Math.random() * 2);
      var time = 100;
            for (var i = 0; i <  _aSpritesArrays[playerID].length; i++) {
                new createjs.Tween.get(_aSpritesArrays[playerID][i])
                        .to({rotation: rotation}, time)
                        .to({rotation: -rotation, alpha: 0.5}, time*2)
                        .to({rotation: rotation}, time)
                        .to({rotation: -rotation}, time*2)
                        .to({rotation: 0}, time);

            }
        
    };
    this.update = function ()
    {
        if (s_oGame.getTurn() === 0 && s_bOnSelect)
        {
            _oTextTurn.visible = true;
            _oTextTurn.text = "Player One";
            _oTextTurn.x = 100;
            _oTextTurn.y = 30;
        } else if (s_oGame.getTurn() === 1 && s_bOnSelect)
        {
            _oTextTurn.text = "Player Two";

            new createjs.Tween.get(_oTextTurn).to({x: 600}, 500, createjs.Ease.backInOut);
        }
    }

    this.init();
    var _oThis = this;
}

var s_oGameSection;

