function CPreloader() {
    var _iMaskWidth;
    var _iMaskHeight;
    var _oLoadingText;
    var _oProgressBar;
    var _oMaskPreloader;
    var _oFade;
    var _oContainer;
    var _oSprite;
    var _iSpriteW;
    this._init = function () {
        s_oSpriteLibrary.init(this._onImagesLoaded, this._onAllImagesLoaded, this);
        s_oSpriteLibrary.addSprite("bg_preloader", "./sprites/bg_preloader.jpg");
        s_oSpriteLibrary.addSprite("progress_bar", "./sprites/progress_bar.png");
        s_oSpriteLibrary.loadSprites();

        _oContainer = new createjs.Container();
        s_oStage.addChild(_oContainer);
    };

    this.unload = function () {
        _oContainer.removeAllChildren();
    };

    this.hide = function () {
        var oParent = this;
        setTimeout(function () {
            createjs.Tween.get(_oFade).to({alpha: 1}, 500).call(function () {
                oParent.unload();
                s_oMain.gotoMenu();
            });
        }, 1000);
    };

    this._onImagesLoaded = function () {

    };

    this._onAllImagesLoaded = function () {
        this.attachSprites();

        s_oMain.preloaderReady();
    };

    this.attachSprites = function () {

        var oBg = createBitmap(s_oSpriteLibrary.getSprite('bg_preloader'));
        

        _oContainer.addChild(oBg);

        _oSprite = s_oSpriteLibrary.getSprite('progress_bar');
        _oProgressBar = createBitmap(_oSprite);
        _oProgressBar.x = CANVAS_WIDTH / 2 - (_oSprite.width / 2);
        _oProgressBar.y = CANVAS_HEIGHT - 90;
        _oContainer.addChild(_oProgressBar);
        _iSpriteW = _oSprite.width / 2;
        _iMaskWidth = _oSprite.width;
        _iMaskHeight = _oSprite.height;
        _oMaskPreloader = new createjs.Shape();
        _oMaskPreloader.graphics.beginFill("rgba(255,255,255,0.01)").drawRect(_oProgressBar.x, _oProgressBar.y, 1, _iMaskHeight);

        _oContainer.addChild(_oMaskPreloader);

        _oProgressBar.mask = _oMaskPreloader;

        _oLoadingText = new createjs.Text("", "30px " + PRIMARY_FONT, "#fff");
        _oLoadingText.x = CANVAS_WIDTH / 2;
        _oLoadingText.y = CANVAS_HEIGHT -100;
        _oLoadingText.shadow = new createjs.Shadow("#000", 2, 2, 2);
        _oLoadingText.textBaseline = "alphabetic";
        _oLoadingText.textAlign = "center";
        _oContainer.addChild(_oLoadingText);

        _oFade = new createjs.Shape();
        _oFade.graphics.beginFill("black").drawRect(0, 0, CANVAS_WIDTH, CANVAS_HEIGHT);
        _oFade.alpha = 0;

        _oContainer.addChild(_oFade);

    };

    this.refreshLoader = function (iPerc) {
        _oLoadingText.text = iPerc + "%";

        _oMaskPreloader.graphics.clear();
        var iNewMaskWidth = Math.floor((iPerc * _iMaskWidth) / 100);
        _oMaskPreloader.graphics.beginFill("rgba(255,255,255,0)").drawRect(_oProgressBar.x, CANVAS_HEIGHT - 100, iNewMaskWidth, _iMaskHeight);
        //Cthis.refreshGUIPos(s_iOffsetX, s_iOffsetY);

    };
    
    this.refreshGUIPos = function (iNewX, iNewY) {
         
        _oLoadingText.x = CANVAS_WIDTH / 2 + iNewX;
        _oLoadingText.y = CANVAS_HEIGHT -100 - iNewY;
        
        _oProgressBar.x = (CANVAS_WIDTH / 2 - _iSpriteW) + iNewX;
        _oProgressBar.y = CANVAS_HEIGHT - 100 - iNewY;
        
        _oMaskPreloader.x = _oProgressBar.x;
        _oMaskPreloader.y = - _oProgressBar.y;
        

    };
    
    this._init();
}